<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
// no direct access
defined('_JEXEC') or die('Restricted access');

class JElementJSeblodSectionsCats3 extends JElement
{

	var	$_name = 'jSeblodSectionsCats3';

	function fetchElement($name, $value, &$node, $control_name){
		
		global $mainframe;
		
		$db = &JFactory::getDBO();
		
		$allow_categories ='';
		
		$params = JRequest::getVar("params");
		if(!empty($params) && $mainframe->isSite()){
			$selected = $params['category'];
			
		}else{
			$selected = $value;
		}
		
		if(!empty($value) && $mainframe->isSite()){
			if( !is_array($value) )
				$value = array($value);
			$allow_categories = ' AND c.id IN ('.implode(',',$value).') ';
			if(in_array(0,$value)){
				$fields['Uncategorized']['name'] = 'Uncategorized';
				$fields['Uncategorized']['options'][] = JHTML::_( 'select.option', 0, 'Uncategorized' );
			}
		}else {
			$fields['Uncategorized']['name'] = 'Uncategorized';
			$fields['Uncategorized']['options'][] = JHTML::_( 'select.option', 0, 'Uncategorized' );
		}
		
		$query = "  SELECT s.title AS section,c.title AS category,c.id 
		FROM #__sections AS s  
		Inner Join #__categories AS c ON s.id = c.section 
		WHERE c.published = 1 AND s.published = 1 ".$allow_categories.
		"GROUP BY c.title 
		ORDER BY section,category ";
		
		$db->setQuery( $query );
		$result = $db->loadObjectList();

		foreach( $result as $field ){
			$fields[$field->section]['name'] = $field->section;
			$fields[$field->section]['options'][] = JHTML::_( 'select.option', $field->id, $field->category );
		}
		
		foreach( $fields as $key => $field ) {
			$option_list[] = JHTML::_( 'select.optgroup', $fields[$key]['name'] );
			$option_list = array_merge( $option_list, $fields[$key]['options'] );
		}
		$output	= JHTML::_( 'select.genericlist',  $option_list, "{$control_name}[{$name}][]", 'class="inputbox" style="width:90%;" multiple="multiple" size="10"', 'value', 'text', $selected );
		
		return $output;
	}
}
