<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
// no direct access
defined('_JEXEC') or die('Restricted access');

class JElementJSeblodFields2 extends JElement
{

	var	$_name = 'JSeblodFields2';

	function fetchElement($name, $value, &$node, $control_name){
		
		global $mainframe;
		
		$db = &JFactory::getDBO();
		$allow_fields ='';
		$params = JRequest::getVar("params");
		if(!empty($params) && $mainframe->isSite()){
			$selected = $params['fields'];
		}else{
			$selected = $value;
		}
		
		if(!empty($value) && $mainframe->isSite()){
			if( !is_array($value) )
				$value = array($value);
			foreach ($value as $val) {
				$field = explode("^",$val);
				$fields[] = $field[1];
			}
			
			$allow_fields = ' AND  items.name IN ("'.implode('","',$fields).'") ';
		}
		
		$query = " SELECT t.title AS typetitle,t.name AS type, items.title AS itemtitle,items.name AS item 
		FROM #__jseblod_cck_types AS t
		Inner Join #__jseblod_cck_type_item AS type_item ON t.id = type_item.typeid
		Inner Join #__jseblod_cck_items AS items ON items.id = type_item.itemid
		Inner Join #__jseblod_cck_items_types AS items_types ON items_types.id = items.type
		WHERE items_types.id IN  (1,2,3,4,5,9,26,30)".$allow_fields."
		GROUP BY t.name,items.name
		ORDER BY typetitle, itemtitle ";
		
		$db->setQuery( $query );
		$result = $db->loadObjectList();
		$fields = array();
		foreach( $result as $field ){
			$fields[$field->typetitle]['name'] = $field->typetitle;
			$fields[$field->typetitle]['options'][] = JHTML::_( 'select.option', $field->type.'^'.$field->item, $field->itemtitle );
		}
		
		foreach( $fields as $key => $field ) {
			$option_list[] = JHTML::_( 'select.optgroup', $fields[$key]['name'] );
			$option_list = array_merge( $option_list, $fields[$key]['options'] );
		}
		$output	= JHTML::_( 'select.genericlist',  $option_list, "{$control_name}[{$name}][]", $mainframe->isSite() ? '' : 'class="inputbox" style="width:90%;" multiple="multiple" size="20"', 'value', 'text', $selected );
		
		return $output;
	}
}
