<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
// no direct access
defined('_JEXEC') or die('Restricted access');

class JElementJSeblodtypes16 extends JElement
{

	var	$_name = 'JSeblodtypes16';

	function fetchElement($name, $value, &$node, $control_name){
		
		global $mainframe;
		
		$db = &JFactory::getDBO();
		$allow_types ='';
		$params = JRequest::getVar("params");
		if(!empty($params) && $mainframe->isSite()){
			$selected = $params['types'];
		}else{
			$selected = $value;
		}
		
		if(!empty($value) && $mainframe->isSite()){
			if( !is_array($value) )
				$value = array($value);
			$allow_types = ' AND s.name IN ("'.implode('","',$value).'") ';
		}
		
		$query = "SELECT s.title,s.name, cc.title AS categorytitle 
		FROM #__jseblod_cck_types AS s 
		LEFT JOIN #__jseblod_cck_types_categories AS cc ON cc.id = s.category 
  		LEFT JOIN #__jseblod_cck_type_item AS ccc ON ccc.typeid = s.id 
  		LEFT JOIN #__jseblod_cck_items AS cccc ON cccc.id = ccc.itemid 
  		WHERE s.published = 1 AND cc.display > 0 AND cc.id AND ccc.client = 'admin' AND cccc.type = 25 AND cccc.bool2 = 0".$allow_types."
  		GROUP BY s.id
  		ORDER BY categorytitle, s.title ";
		
		$db->setQuery( $query );
		$result = $db->loadObjectList();

		foreach( $result as $field ){
			$fields[$field->categorytitle]['name'] = $field->categorytitle;
			$fields[$field->categorytitle]['options'][] = JHTML::_( 'select.option', $field->name, $field->title );
		}
		
		foreach( $fields as $key => $field ) {
			$option_list[] = JHTML::_( 'select.optgroup', $fields[$key]['name'] );
			$option_list = array_merge( $option_list, $fields[$key]['options'] );
		}
		$output	= JHTML::_( 'select.genericlist',  $option_list, "{$control_name}[{$name}][]", 'class="inputbox" style="width:90%;" multiple="multiple" size="10"', 'value', 'text', $selected );
		
		return $output;
	}
}
